(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/material/button'), require('@angular/material/checkbox'), require('@angular/material/dialog'), require('@angular/material/input'), require('@angular/material/progress-bar'), require('@angular/material/progress-spinner'), require('@angular/material/select'), require('@angular/material/tooltip'), require('@angular/common/http'), require('@auth0/angular-jwt'), require('rxjs'), require('@angular/platform-browser/animations'), require('@angular/material/list'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('@cleavelandprice/ngx-lib', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/material/button', '@angular/material/checkbox', '@angular/material/dialog', '@angular/material/input', '@angular/material/progress-bar', '@angular/material/progress-spinner', '@angular/material/select', '@angular/material/tooltip', '@angular/common/http', '@auth0/angular-jwt', 'rxjs', '@angular/platform-browser/animations', '@angular/material/list', '@angular/platform-browser'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.cleavelandprice = global.cleavelandprice || {}, global.cleavelandprice['ngx-lib'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.ng.material.button, global.ng.material.checkbox, global.ng.material.dialog, global.ng.material.input, global.ng.material.progressBar, global.ng.material.progressSpinner, global.ng.material.select, global.ng.material.tooltip, global.ng.common.http, global.angularJwt, global.rxjs, global.ng.platformBrowser.animations, global.ng.material.list, global.ng.platformBrowser));
}(this, (function (exports, core, common, forms, button, checkbox, dialog, input, progressBar, progressSpinner, select, tooltip, http, angularJwt, rxjs, animations, list, platformBrowser) { 'use strict';

    (function (ConfirmationDialogMode) {
        ConfirmationDialogMode[ConfirmationDialogMode["OkCancel"] = 0] = "OkCancel";
        ConfirmationDialogMode[ConfirmationDialogMode["YesNo"] = 1] = "YesNo";
        ConfirmationDialogMode[ConfirmationDialogMode["TrueFalse"] = 2] = "TrueFalse";
        ConfirmationDialogMode[ConfirmationDialogMode["Custom"] = 3] = "Custom";
    })(exports.ConfirmationDialogMode || (exports.ConfirmationDialogMode = {}));

    var DialogComponent = /** @class */ (function () {
        function DialogComponent() {
            this.closed = new core.EventEmitter();
            this.ConfirmationDialogMode = exports.ConfirmationDialogMode;
            this.mode = exports.ConfirmationDialogMode.OkCancel;
            this.customTrueFalseText = null;
        }
        DialogComponent.prototype.ngOnInit = function () {
            if (this.data) {
                this.title = this.data.title || null;
                this.message = this.data.message || null;
                this.checkboxMessage = this.data.checkboxMessage || null;
                this.placeholder = this.data.placeholder || null;
                this.userInput = this.data.value || null;
                this.mode = this.data.mode || exports.ConfirmationDialogMode.OkCancel;
                this.customTrueFalseText = this.data.customTrueFalseText;
            }
        };
        DialogComponent.prototype.close = function () {
            var data;
            switch (this.dialogType) {
                case 'message':
                    data = this.checkboxMessage ?
                        {
                            checkbox: this.checkboxValue || false
                        } :
                        null;
                    break;
                case 'input':
                    data = this.checkboxMessage ?
                        {
                            response: this.userInput,
                            checkbox: this.checkboxValue || false
                        } :
                        this.userInput;
                    break;
                case 'confirmation':
                    data = this.checkboxMessage ?
                        {
                            response: true,
                            checkbox: this.checkboxValue || false
                        } :
                        true;
                    break;
            }
            this.closed.emit(data);
        };
        DialogComponent.prototype.cancel = function () {
            var data;
            if (this.dialogType === 'confirmation') {
                data = this.checkboxMessage ?
                    {
                        response: false,
                        checkbox: this.checkboxValue || false
                    } :
                    false;
            }
            this.closed.emit(data);
        };
        return DialogComponent;
    }());
    DialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-dialog',
                    template: "<h2 *ngIf=\"title\" mat-dialog-title [innerHTML]=\"title\"></h2>\n\n<mat-dialog-content>\n    <div *ngIf=\"message\" [innerHTML]=\"message\"></div>\n\n    <mat-form-field *ngIf=\"dialogType === 'input'\">\n        <textarea matInput [placeholder]=\"placeholder\" [(ngModel)]=\"userInput\"></textarea>\n    </mat-form-field>\n\n    <div id=\"checkbox\" *ngIf=\"checkboxMessage\">\n        <mat-checkbox [(ngModel)]=\"checkboxValue\">\n            <span [innerHTML]=\"checkboxMessage\"></span>\n        </mat-checkbox>\n    </div>\n</mat-dialog-content>\n\n<mat-dialog-actions>\n    <button mat-raised-button (click)=\"close()\" [disabled]=\"dialogType === 'input' && !userInput\">\n        <span [ngSwitch]=\"mode\">\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">Yes</span>\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">True</span>\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[0] }}</span>\n            <span *ngSwitchDefault>OK</span>\n        </span>\n    </button>\n    <button *ngIf=\"dialogType !== 'message'\" mat-raised-button (click)=\"cancel()\">\n        <span [ngSwitch]=\"mode\">\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">No</span>\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">False</span>\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[1] }}</span>\n            <span *ngSwitchDefault>Cancel</span>\n        </span>\n    </button>\n</mat-dialog-actions>",
                    styles: ["mat-form-field{margin-top:2em;width:100%}#checkbox{margin:2em 0}"]
                },] }
    ];
    DialogComponent.propDecorators = {
        dialogType: [{ type: core.Input }],
        data: [{ type: core.Input }],
        closed: [{ type: core.Output }]
    };

    var ConfirmationDialogComponent = /** @class */ (function () {
        function ConfirmationDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        return ConfirmationDialogComponent;
    }());
    ConfirmationDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-confirmation-dialog',
                    template: "<cp-dialog\n  [data]=\"data\"\n  [dialogType]=\"'confirmation'\"\n  (closed)=\"dialogRef.close($event)\">\n</cp-dialog>"
                },] }
    ];
    ConfirmationDialogComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
    ]; };

    var InputDialogComponent = /** @class */ (function () {
        function InputDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        return InputDialogComponent;
    }());
    InputDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-input-dialog',
                    template: "<cp-dialog\n  [data]=\"data\"\n  [dialogType]=\"'input'\"\n  (closed)=\"dialogRef.close($event)\">\n</cp-dialog>"
                },] }
    ];
    InputDialogComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
    ]; };

    var MessageDialogComponent = /** @class */ (function () {
        function MessageDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        return MessageDialogComponent;
    }());
    MessageDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-message-dialog',
                    template: "<cp-dialog\n  [data]=\"data\"\n  [dialogType]=\"'message'\"\n  (closed)=\"dialogRef.close($event)\">\n</cp-dialog>"
                },] }
    ];
    MessageDialogComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
    ]; };

    //#region Imports
    //#endregion
    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        return DialogModule;
    }());
    DialogModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        button.MatButtonModule,
                        checkbox.MatCheckboxModule,
                        input.MatInputModule,
                        dialog.MatDialogModule
                    ],
                    declarations: [
                        DialogComponent,
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ],
                    exports: [
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ],
                    entryComponents: [
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ]
                },] }
    ];

    var AuthenticationServiceConfig = /** @class */ (function () {
        function AuthenticationServiceConfig() {
        }
        return AuthenticationServiceConfig;
    }());

    var SharePointServiceConfig = /** @class */ (function () {
        function SharePointServiceConfig() {
        }
        return SharePointServiceConfig;
    }());

    //#region Imports
    //#endregion
    var SharePointService = /** @class */ (function () {
        //#endregion
        function SharePointService(config, http) {
            this.config = config;
            this.http = http;
        }
        //#region Utilities
        SharePointService.prototype.getListItems = function (request) {
            if (!request.username) {
                request.username = this.config.userName;
            }
            if (!request.password) {
                request.password = this.config.password;
            }
            return this.http.post(this.config.sharePointApiUrl + "/listitems", request);
        };
        /*getListItemsSimple(list: string, view: string, site?: string, limit?: string): Observable<SharePointListItem[]> {
          return this.http.get<SharePointListItem[]>(`${this.config.sharePointApiUrl}/${list}/${view}/${site}/${limit}`);
        }*/
        SharePointService.prototype.getPeople = function (request, storePeople) {
            var _this = this;
            // Do we already have people stored locally?
            if (this.users) {
                return rxjs.of(this.users);
            }
            if (!request.username) {
                request.username = this.config.userName;
            }
            if (!request.password) {
                request.password = this.config.password;
            }
            // Should we store people locally for subsequent calls?
            if (storePeople) {
                this.http.post(this.config.sharePointApiUrl + "/users", request)
                    .subscribe(function (users) { return _this.users = users; });
            }
            return this.http.post(this.config.sharePointApiUrl + "/users", request);
        };
        SharePointService.prototype.getPhotos = function (storePhotos) {
            var _this = this;
            // Do we already have photos stored locally?
            if (this.photos) {
                return rxjs.of(this.photos);
            }
            var request = {
                list: 'Employee Thumbnail Photos',
                site: 'http://cpsp1/DigitalDisplay',
                username: this.config.userName,
                password: this.config.password,
                additionalPropertiesToRetrieve: ['EncodedAbsUrl']
            };
            // Should we store photos locally for subsequent calls?
            if (storePhotos) {
                this.http.post(this.config.sharePointApiUrl + "/listitems", request)
                    .subscribe(function (photos) { return _this.photos = photos; });
            }
            return this.http.post(this.config.sharePointApiUrl + "/listitems", request);
        };
        return SharePointService;
    }());
    SharePointService.decorators = [
        { type: core.Injectable }
    ];
    SharePointService.ctorParameters = function () { return [
        { type: SharePointServiceConfig, decorators: [{ type: core.Optional }] },
        { type: http.HttpClient }
    ]; };

    //#region Imports
    //#endregion
    /**
     * Authenticate Active Directory user
     */
    var AuthenticationService = /** @class */ (function () {
        //#endregion
        //#region Lifecycle
        /**
         * @ignore
         */
        function AuthenticationService(config, http, sharePointService) {
            this.http = http;
            this.sharePointService = sharePointService;
            this.authenticatedChanged = new core.EventEmitter();
            this.authenticatingChanged = new core.EventEmitter();
            /**
             * Flag set to true while the service is attempting to authenticate the user
             */
            this.authenticating = false;
            /**
             * Flag set to true when the user is successfully authenticated
             */
            this.authenticated = false;
            this.authenticationApiUrl = config.authenticationApiUrl;
            this.checkForExistingToken();
        }
        //#endregion
        //#region Utilities
        /**
         * Authenticate the user and store the token in Local Storage
         *
         * @param username AD sAMAccountName
         * @param password
         * @param adminGroup AD group that determines if authenticated user is considered an administrator of the app
         */
        AuthenticationService.prototype.login = function (username, password, adminGroup) {
            var _this = this;
            var request = {
                username: username,
                password: password,
                adminGroup: adminGroup
            };
            this.authenticating = true;
            this.authenticatingChanged.emit(this.authenticating);
            this.http.request('POST', this.authenticationApiUrl, { responseType: 'text', body: request })
                // this.http.post<string>(this.authenticationApiUrl, request)
                .subscribe(function (token) { return _this.validateUser(token); }, function (err) {
                _this.authenticating = false;
                _this.authenticatingChanged.emit(_this.authenticating);
            });
        };
        /**
         * Logout the user and delete the token from Local Storage
         */
        AuthenticationService.prototype.logout = function () {
            if (localStorage.getItem('token')) {
                localStorage.removeItem('token');
            }
            this.authenticatedUser = null;
            this.authenticated = false;
            this.authenticatedChanged.emit(false);
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.validateUser = function (token) {
            if (!token) {
                return;
            }
            var jwtHelper = new angularJwt.JwtHelperService();
            var decoded = jwtHelper.decodeToken(token);
            if (jwtHelper.isTokenExpired(token)) {
                this.logout();
                return;
            }
            this.authenticatedUser = decoded;
            this.authenticatedUser.accountName = decoded.winaccountname;
            this.authenticatedUser.admin = decoded.role === 'Admin';
            localStorage.setItem('token', token);
            this.getPhoto();
            this.authenticated = true;
            this.authenticatedChanged.emit(this.authenticated);
            this.authenticating = false;
            this.authenticatingChanged.emit(this.authenticating);
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.getPhoto = function () {
            var _this = this;
            this.sharePointService.getPhotos()
                .subscribe(function (photos) {
                // The user may have been logged out by the time the photos came back
                if (!_this.authenticatedUser || !_this.authenticatedUser.employeeNumber) {
                    return;
                }
                var photo = photos.find(function (pic) { return +pic.employeeNumber === +_this.authenticatedUser.employeeNumber; });
                if (photo) {
                    _this.authenticatedUser.photoUrl = photo.encodedAbsUrl;
                }
            });
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.checkForExistingToken = function () {
            if (localStorage.getItem('token')) {
                this.validateUser(localStorage.getItem('token'));
            }
        };
        return AuthenticationService;
    }());
    AuthenticationService.decorators = [
        { type: core.Injectable }
    ];
    AuthenticationService.ctorParameters = function () { return [
        { type: AuthenticationServiceConfig, decorators: [{ type: core.Optional }] },
        { type: http.HttpClient },
        { type: SharePointService }
    ]; };
    AuthenticationService.propDecorators = {
        authenticatedChanged: [{ type: core.Output }],
        authenticatingChanged: [{ type: core.Output }]
    };

    var LoginFormComponent = /** @class */ (function () {
        function LoginFormComponent(dialogRef, sharePointService, authenticationService, data) {
            this.dialogRef = dialogRef;
            this.sharePointService = sharePointService;
            this.authenticationService = authenticationService;
            this.data = data;
            this.adminGroup = data.adminGroup;
        }
        LoginFormComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.authenticationService.authenticatedChanged
                .subscribe(function (authenticated) {
                if (authenticated) {
                    _this.dialogRef.close();
                }
            });
        };
        LoginFormComponent.prototype.authenticate = function () {
            if (!this.sharePointService || !this.username || !this.password) {
                return;
            }
            this.authenticationService.login(this.username, this.password, this.adminGroup);
        };
        return LoginFormComponent;
    }());
    LoginFormComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-login-form',
                    template: "<h2 mat-dialog-title>\n  <span *ngIf=\"!authenticationService.authenticating\">Login</span>\n  <span *ngIf=\"authenticationService.authenticating\">Authenticating...</span>\n</h2>\n\n<mat-dialog-content [class.loginError]=\"loginError\">\n  <div id=\"spinner\" *ngIf=\"authenticationService.authenticating\">\n    <mat-progress-spinner color=\"primary\" mode=\"indeterminate\"></mat-progress-spinner>\n  </div>\n\n  <div *ngIf=\"!authenticationService.authenticating\">\n    <div>\n      <mat-form-field>\n        <input matInput placeholder=\"Username\" [(ngModel)]=\"username\" name=\"username\" required (keyup.enter)=\"authenticate()\">\n      </mat-form-field>\n    </div>\n\n    <div>\n      <mat-form-field>\n        <input matInput type=\"password\" placeholder=\"Password\" [(ngModel)]=\"password\" name=\"password\" required (keyup.enter)=\"authenticate()\">\n      </mat-form-field>\n    </div>\n  </div>\n\n  <div *ngIf=\"!authenticationService.authenticating && loginError\" class=\"alert alert-danger\">\n    Bad username or password\n  </div>\n</mat-dialog-content>\n\n<mat-dialog-actions *ngIf=\"!authenticationService.authenticating\">\n  <button type=\"button\" mat-raised-button (click)=\"authenticate()\">OK</button>\n  <button type=\"button\" mat-button (click)=\"dialogRef.close()\">Cancel</button>\n</mat-dialog-actions>",
                    styles: ["#spinner{align-items:center;display:flex;height:100%;justify-content:center;width:100%}mat-dialog-content{height:150px}mat-dialog-content.loginError{height:200px}"]
                },] }
    ];
    LoginFormComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: SharePointService },
        { type: AuthenticationService },
        { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
    ]; };

    var LoginComponent = /** @class */ (function () {
        function LoginComponent(dialog, authenticationService) {
            this.dialog = dialog;
            this.authenticationService = authenticationService;
        }
        LoginComponent.prototype.login = function () {
            this.dialog.open(LoginFormComponent, {
                data: { adminGroup: this.adminGroup }
            });
        };
        LoginComponent.prototype.confirmLogout = function () {
            var _this = this;
            var dialogRef = this.dialog.open(ConfirmationDialogComponent, {
                data: { message: "Are you sure you want to logout?" }
            });
            dialogRef.afterClosed().subscribe(function (result) {
                if (result) {
                    _this.authenticationService.logout();
                }
            });
        };
        return LoginComponent;
    }());
    LoginComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-login',
                    template: "<div id=\"user-id\">\n  <i id=\"unauthenticated-user-image\" *ngIf=\"!authenticationService.authenticated\"\n    class=\"fa fa-user-circle\"\n    [class.fa-spin]=\"authenticationService.authenticating\"\n    aria-hidden=\"true\"\n    matTooltip=\"Login\"\n    (click)=\"login()\"></i>\n\n  <img id=\"authenticated-user-image\"\n    *ngIf=\"authenticationService.authenticated && authenticationService.authenticatedUser.photoUrl\"\n    [src]=\"authenticationService.authenticatedUser.photoUrl\"\n    matTooltip=\"Logout\"\n    (click)=\"confirmLogout()\" />\n\n  <i id=\"authenticated-user-image\"\n    *ngIf=\"authenticationService.authenticated && !authenticationService.authenticatedUser.photoUrl\"\n    class=\"fa fa-user-circle\"\n    matTooltip=\"Logout\"\n    (click)=\"confirmLogout()\"></i>\n\n  <div id=\"user-name\" *ngIf=\"authenticationService.authenticated\">\n    {{ authenticationService.authenticatedUser.displayName }}\n  </div>\n</div>",
                    styles: ["#user-id{display:flex;font-family:Verdana,Geneva,Tahoma,sans-serif;height:2em;padding:.3em}.fa{font-size:2em}img{border-radius:100%;height:2em;width:2em}#user-id>div{align-items:center;display:flex;font-size:1.15em;height:100%;margin-left:.75em}"]
                },] }
    ];
    LoginComponent.ctorParameters = function () { return [
        { type: dialog.MatDialog },
        { type: AuthenticationService }
    ]; };
    LoginComponent.propDecorators = {
        adminGroup: [{ type: core.Input }]
    };

    //#region Imports
    //#endregion
    /**
     * Provides a component and a service that allows you to perform Active/Directory authentication
     */
    var AuthenticationModule = /** @class */ (function () {
        function AuthenticationModule(parentModule) {
            if (parentModule) {
                throw new Error('AuthenticationModule is already loaded. Import it in the AppModule only');
            }
        }
        AuthenticationModule.forRoot = function (authenticationConfig) {
            return {
                ngModule: AuthenticationModule,
                providers: [
                    AuthenticationService,
                    { provide: AuthenticationServiceConfig, useValue: authenticationConfig }
                ]
            };
        };
        return AuthenticationModule;
    }());
    AuthenticationModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        button.MatButtonModule,
                        checkbox.MatCheckboxModule,
                        dialog.MatDialogModule,
                        input.MatInputModule,
                        progressBar.MatProgressBarModule,
                        progressSpinner.MatProgressSpinnerModule,
                        tooltip.MatTooltipModule,
                        select.MatSelectModule,
                        DialogModule
                    ],
                    declarations: [
                        LoginComponent,
                        LoginFormComponent
                    ],
                    exports: [
                        LoginComponent,
                        LoginFormComponent
                    ],
                    providers: [],
                    entryComponents: [
                        LoginFormComponent
                    ]
                },] }
    ];
    AuthenticationModule.ctorParameters = function () { return [
        { type: AuthenticationModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    var EmailServiceConfig = /** @class */ (function () {
        function EmailServiceConfig() {
        }
        return EmailServiceConfig;
    }());

    //#region Imports
    //#endregion
    var EmailService = /** @class */ (function () {
        function EmailService(config, http) {
            this.http = http;
            this.emailServiceConfig = config;
        }
        EmailService.prototype.send = function (email) {
            var dto = {
                server: this.emailServiceConfig.server,
                smtpPort: this.emailServiceConfig.smtpPort,
                sender: this.emailServiceConfig.sender,
                subject: email.subject,
                content: email.content,
                recipients: email.recipients
            };
            return this.http.post(this.emailServiceConfig.emailApiUrl, dto);
        };
        return EmailService;
    }());
    EmailService.decorators = [
        { type: core.Injectable }
    ];
    EmailService.ctorParameters = function () { return [
        { type: EmailServiceConfig, decorators: [{ type: core.Optional }] },
        { type: http.HttpClient }
    ]; };

    //#region Imports
    //#endregion
    var EmailModule = /** @class */ (function () {
        function EmailModule(parentModule) {
            if (parentModule) {
                throw new Error('EmailModule is already loaded. Import it in the AppModule only');
            }
        }
        EmailModule.forRoot = function (emailConfig) {
            return {
                ngModule: EmailModule,
                providers: [
                    EmailService,
                    { provide: EmailServiceConfig, useValue: emailConfig }
                ]
            };
        };
        return EmailModule;
    }());
    EmailModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [],
                    exports: []
                },] }
    ];
    EmailModule.ctorParameters = function () { return [
        { type: EmailModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    var EmployeeServiceConfig = /** @class */ (function () {
        function EmployeeServiceConfig() {
        }
        return EmployeeServiceConfig;
    }());

    //#region Imports
    //#endregion
    var EmployeeService = /** @class */ (function () {
        //#endregion
        //#region Lifecycle
        function EmployeeService(config, http) {
            this.http = http;
            this.employeeApiUrl = config.employeeApiUrl;
        }
        //#endregion
        //#region Utilities
        EmployeeService.prototype.getEmployees = function (storeEmployees, includeDisabled) {
            var _this = this;
            if (storeEmployees === void 0) { storeEmployees = false; }
            if (includeDisabled === void 0) { includeDisabled = false; }
            // Do we already have employees stored locally?
            if (this.employees) {
                return rxjs.of(this.employees);
                // return Observable.of(this.employees);
            }
            // Should we store employees locally for subsequent calls?
            if (storeEmployees) {
                this.http.get(this.employeeApiUrl + "/false/" + includeDisabled)
                    .subscribe(function (emps) { return _this.employees = emps; });
            }
            return this.http.get(this.employeeApiUrl + "/false/" + includeDisabled);
        };
        EmployeeService.prototype.getEmployee = function (sAMAccountName) {
            return this.http.get(this.employeeApiUrl + "/name/" + sAMAccountName);
        };
        return EmployeeService;
    }());
    EmployeeService.decorators = [
        { type: core.Injectable }
    ];
    EmployeeService.ctorParameters = function () { return [
        { type: EmployeeServiceConfig, decorators: [{ type: core.Optional }] },
        { type: http.HttpClient }
    ]; };

    var DepartmentsPipe = /** @class */ (function () {
        function DepartmentsPipe() {
        }
        DepartmentsPipe.prototype.transform = function (employees, args) {
            var departments = [];
            employees
                .filter(function (emp) { return emp.department; })
                .forEach(function (emp) {
                if (departments.indexOf(emp.department) === -1) {
                    departments.push(emp.department);
                }
            });
            return departments.sort();
        };
        return DepartmentsPipe;
    }());
    DepartmentsPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'departments'
                },] }
    ];

    var EmployeeByDnPipe = /** @class */ (function () {
        function EmployeeByDnPipe() {
        }
        EmployeeByDnPipe.prototype.transform = function (employees, dn) {
            return employees
                .find(function (emp) { return emp.distinguishedName.toLowerCase() === dn.toLowerCase(); });
        };
        return EmployeeByDnPipe;
    }());
    EmployeeByDnPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'employeeByDn'
                },] }
    ];

    var EmployeePhotoUrlPipe = /** @class */ (function () {
        function EmployeePhotoUrlPipe() {
        }
        EmployeePhotoUrlPipe.prototype.transform = function (employee, photos) {
            if (!photos) {
                return null;
            }
            // Try to match by employeeNumber, accountName, or title
            var photo = photos
                .find(function (pic) { return (pic.employeeNumber && employee.employeeNumber && +pic.employeeNumber === +employee.employeeNumber) ||
                (pic.accountName && pic.accountName.toLowerCase() === employee.sAMAccountName.toLowerCase()) ||
                (pic.title && pic.title.toLowerCase() === employee.displayName.toLowerCase()); });
            if (!photo) {
                console.log("No photo match for " + employee.displayName);
            }
            return photo ? photo.encodedAbsUrl : null;
        };
        return EmployeePhotoUrlPipe;
    }());
    EmployeePhotoUrlPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'employeePhotoUrl'
                },] }
    ];

    var EmployeesWithPropertyValuePipe = /** @class */ (function () {
        function EmployeesWithPropertyValuePipe() {
        }
        EmployeesWithPropertyValuePipe.prototype.transform = function (employees, propertyName, propertyValue) {
            return employees
                .filter(function (emp) { return emp[propertyName] && emp[propertyName] === propertyValue; });
        };
        return EmployeesWithPropertyValuePipe;
    }());
    EmployeesWithPropertyValuePipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'employeesWithPropertyValue'
                },] }
    ];

    var FilterEmployeesPipe = /** @class */ (function () {
        function FilterEmployeesPipe() {
        }
        FilterEmployeesPipe.prototype.transform = function (employees, filter) {
            return filter ?
                employees
                    .filter(function (emp) { return emp.displayName.toLowerCase().indexOf(filter.toLowerCase()) !== -1 ||
                    (emp.department && emp.department.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                    (emp.title && emp.title.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                    emp.sAMAccountName.toLowerCase().indexOf(filter.toLowerCase()) !== -1; }) :
                employees;
        };
        return FilterEmployeesPipe;
    }());
    FilterEmployeesPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'filterEmployees'
                },] }
    ];

    var IsMemberOfPipe = /** @class */ (function () {
        function IsMemberOfPipe() {
        }
        IsMemberOfPipe.prototype.transform = function (employee, groupName) {
            return employee.memberOf &&
                (employee.memberOf.find(function (m) { return m.toLowerCase().indexOf(groupName.toLowerCase()) !== -1; }) !== undefined);
        };
        return IsMemberOfPipe;
    }());
    IsMemberOfPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'isMemberOf'
                },] }
    ];

    var SortEmployeesPipe = /** @class */ (function () {
        function SortEmployeesPipe() {
        }
        SortEmployeesPipe.prototype.transform = function (employees, sortBy, dataType, reverse) {
            return this.getSorted(employees, sortBy ? sortBy : 'displayName', dataType ? dataType : 'string', reverse ? reverse : false);
        };
        SortEmployeesPipe.prototype.getSorted = function (employees, sortBy, dataType, reverse) {
            var sorted = employees
                .sort(function (a, b) {
                var valA, valB;
                switch (dataType.toLowerCase()) {
                    case 'string':
                        valA = a[sortBy] ? a[sortBy].toString().toLowerCase() : null;
                        valB = b[sortBy] ? b[sortBy].toString().toLowerCase() : null;
                        break;
                    case 'number':
                        valA = a[sortBy] ? +a[sortBy] : null;
                        valB = b[sortBy] ? +b[sortBy] : null;
                        break;
                    case 'date':
                        valA = a[sortBy] ? a[sortBy] : null;
                        valB = b[sortBy] ? b[sortBy] : null;
                        break;
                }
                if (valA < valB) {
                    return -1;
                }
                if (valA > valB) {
                    return 1;
                }
                return 0;
            });
            return reverse ? sorted.reverse() : sorted;
        };
        return SortEmployeesPipe;
    }());
    SortEmployeesPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'sortEmployees'
                },] }
    ];

    //#region Imports
    //#endregion
    var EmployeeModule = /** @class */ (function () {
        function EmployeeModule(parentModule) {
            if (parentModule) {
                throw new Error('EmployeeModule is already loaded. Import it in the AppModule only');
            }
        }
        EmployeeModule.forRoot = function (employeeConfig) {
            return {
                ngModule: EmployeeModule,
                providers: [
                    EmployeeService,
                    { provide: EmployeeServiceConfig, useValue: employeeConfig }
                ]
            };
        };
        return EmployeeModule;
    }());
    EmployeeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [
                        DepartmentsPipe,
                        EmployeeByDnPipe,
                        EmployeesWithPropertyValuePipe,
                        FilterEmployeesPipe,
                        IsMemberOfPipe,
                        EmployeePhotoUrlPipe,
                        SortEmployeesPipe
                    ],
                    exports: [
                        DepartmentsPipe,
                        EmployeeByDnPipe,
                        EmployeesWithPropertyValuePipe,
                        FilterEmployeesPipe,
                        IsMemberOfPipe,
                        EmployeePhotoUrlPipe,
                        SortEmployeesPipe
                    ]
                },] }
    ];
    EmployeeModule.ctorParameters = function () { return [
        { type: EmployeeModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    var SharePointPhotoUrlPipe = /** @class */ (function () {
        function SharePointPhotoUrlPipe() {
        }
        SharePointPhotoUrlPipe.prototype.transform = function (photo) {
            return photo.encodedAbsUrl;
        };
        return SharePointPhotoUrlPipe;
    }());
    SharePointPhotoUrlPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'sharePointPhotoUrl'
                },] }
    ];

    var SharePointUrlPipe = /** @class */ (function () {
        function SharePointUrlPipe() {
        }
        SharePointUrlPipe.prototype.transform = function (url) {
            return url !== null ? url.split(',')[0] : null;
        };
        return SharePointUrlPipe;
    }());
    SharePointUrlPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'sharePointUrl'
                },] }
    ];

    //#region Imports
    //#endregion
    var SharePointModule = /** @class */ (function () {
        function SharePointModule(parentModule) {
            if (parentModule) {
                throw new Error('SharePointModule is already loaded. Import it in the AppModule only');
            }
        }
        SharePointModule.forRoot = function (sharePointConfig) {
            return {
                ngModule: SharePointModule,
                providers: [
                    SharePointService,
                    { provide: SharePointServiceConfig, useValue: sharePointConfig }
                ]
            };
        };
        return SharePointModule;
    }());
    SharePointModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: [
                        SharePointPhotoUrlPipe,
                        SharePointUrlPipe
                    ],
                    exports: [
                        SharePointPhotoUrlPipe,
                        SharePointUrlPipe
                    ]
                },] }
    ];
    SharePointModule.ctorParameters = function () { return [
        { type: SharePointModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    var UploadServiceConfig = /** @class */ (function () {
        function UploadServiceConfig() {
        }
        return UploadServiceConfig;
    }());

    // https://malcoded.com/posts/angular-file-upload-component-with-express
    var UploadService = /** @class */ (function () {
        function UploadService(http, config) {
            this.http = http;
            this.uploadApiUrl = config.uploadApiUrl;
            this.uploadPath = config.uploadPath || '';
            this.dbAppId = config.dbAppId || '';
            this.externalReferenceId = config.externalReferenceId || '';
            this.comment = config.comment || '';
            // UI configuration
            this.uploadButtonText = config.uploadButtonText;
            this.uploadDialogTitle = config.uploadDialogTitle;
            this.uploadDialogAddFilesButtonText = config.uploadDialogAddFilesButtonText;
            this.uploadDialogCancelButtonText = config.uploadDialogCancelButtonText;
            this.uploadDialogUploadButtonText = config.uploadDialogUploadButtonText;
            this.uploadDialogFinishButtonText = config.uploadDialogFinishButtonText;
        }
        UploadService.prototype.upload = function (files) {
            var _this = this;
            // this will be the our resulting map
            var status = {};
            files.forEach(function (file) {
                // create a new multipart-form for every file
                var formData = new FormData();
                formData.append('file', file, file.name);
                // create a http-post request and pass the form
                // tell it to report the upload progress
                // A 'Destination' header is used to optionally configure the file upload destination (filesystem)
                // A 'DbAppId' header is used to configure the unique identifier of database uploads
                var req = new http.HttpRequest('POST', _this.uploadApiUrl, formData, {
                    reportProgress: true,
                    responseType: 'blob',
                    headers: new http.HttpHeaders()
                        .set('Destination', _this.uploadPath)
                        .set('DbAppId', _this.dbAppId)
                        .set('ExternalReferenceId', _this.externalReferenceId)
                        .set('Comment', _this.comment)
                    /*headers: this.uploadPath ?
                      new HttpHeaders({ 'Destination': this.uploadPath }) :
                      this.dbAppId ?
                        new HttpHeaders({ 'DbAppId': this.dbAppId }) :
                        null*/
                });
                // create a new progress-subject for every file
                var progress = new rxjs.Subject();
                // send the http-request and subscribe for progress-updates
                _this.http.request(req).subscribe(function (event) {
                    if (event.type === http.HttpEventType.UploadProgress) {
                        // calculate the progress percentage
                        var percentDone = Math.round(100 * event.loaded / event.total);
                        // pass the percentage into the progress-stream
                        progress.next(percentDone);
                    }
                    else if (event instanceof http.HttpResponse) {
                        // Close the progress-stream if we get an answer form the API
                        // The upload is complete
                        progress.complete();
                    }
                });
                // Save every progress-observable in a map of all observables
                status[file.name] = {
                    progress: progress.asObservable()
                };
            });
            // return the map of progress.observables
            return status;
        };
        UploadService.prototype.exists = function (fileName) {
            var query = this.uploadApiUrl.toLowerCase().indexOf('filesystem') === -1 ?
                { name: fileName, dbAppId: this.dbAppId } :
                { name: fileName, destination: this.uploadPath };
            return this.http.post(this.uploadApiUrl + "/exists", query);
        };
        UploadService.prototype.download = function (request) {
            return this.http.post(this.uploadApiUrl + "/stream", request, { responseType: 'blob' });
        };
        UploadService.prototype.getUploadInfo = function (request) {
            return this.http.post(this.uploadApiUrl + "/info", request);
        };
        return UploadService;
    }());
    UploadService.decorators = [
        { type: core.Injectable }
    ];
    UploadService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: UploadServiceConfig, decorators: [{ type: core.Optional }] }
    ]; };

    var UploadDialogComponent = /** @class */ (function () {
        function UploadDialogComponent(dialogRef, uploadService) {
            this.dialogRef = dialogRef;
            this.uploadService = uploadService;
            this.files = new Set();
            this.canBeClosed = true;
            this.showCancelButton = true;
            this.uploading = false;
            this.uploadSuccessful = false;
        }
        UploadDialogComponent.prototype.ngOnInit = function () {
            this.uploadDialogTitle = this.uploadService.uploadDialogTitle ?
                this.uploadService.uploadDialogTitle :
                'Upload Files';
            this.uploadDialogAddFilesButtonText = this.uploadService.uploadDialogAddFilesButtonText ?
                this.uploadService.uploadDialogAddFilesButtonText :
                'Add Files';
            this.uploadDialogCancelButtonText = this.uploadService.uploadDialogCancelButtonText ?
                this.uploadService.uploadDialogCancelButtonText :
                'Cancel';
            this.uploadDialogUploadButtonText = this.uploadService.uploadDialogUploadButtonText ?
                this.uploadService.uploadDialogUploadButtonText :
                'Upload';
            this.uploadDialogFinishButtonText = this.uploadService.uploadDialogFinishButtonText ?
                this.uploadService.uploadDialogFinishButtonText :
                'Finish';
            this.primaryButtonText = this.uploadDialogUploadButtonText;
        };
        UploadDialogComponent.prototype.addFiles = function () {
            this.file.nativeElement.click();
        };
        UploadDialogComponent.prototype.onFilesAdded = function () {
            var _this = this;
            var files = this.file.nativeElement.files;
            var _loop_1 = function (key) {
                if (!isNaN(parseInt(key))) {
                    // See if the file already exists
                    this_1.uploadService.exists(files[key].name)
                        .subscribe(function (exists) {
                        if (exists) {
                            _this.existingFileConflict = files[key].name;
                        }
                        if (!exists) {
                            _this.files.add(files[key]);
                        }
                    });
                }
            };
            var this_1 = this;
            for (var key in files) {
                _loop_1(key);
            }
        };
        UploadDialogComponent.prototype.closeDialog = function () {
            var _this = this;
            // if everything was uploaded already, just close the dialog
            if (this.uploadSuccessful) {
                return this.dialogRef.close();
            }
            // set the component state to "uploading"
            this.uploading = true;
            // start the upload and save the progress map
            this.progress = this.uploadService.upload(this.files);
            // convert the progress map into an array
            var allProgressObservables = [];
            for (var key in this.progress) {
                allProgressObservables.push(this.progress[key].progress);
            }
            // Adjust the state variables
            // The OK-button should have the text "Finish" now
            this.primaryButtonText = this.uploadDialogFinishButtonText;
            // The dialog should not be closed while uploading
            this.canBeClosed = false;
            this.dialogRef.disableClose = true;
            // Hide the cancel-button
            this.showCancelButton = false;
            // When all progress-observables are completed...
            rxjs.forkJoin(allProgressObservables).subscribe(function (end) {
                // ... the dialog can be closed again...
                _this.canBeClosed = true;
                _this.dialogRef.disableClose = false;
                // ... the upload was successful...
                _this.uploadSuccessful = true;
                // ... and the component is no longer uploading
                _this.uploading = false;
            });
        };
        return UploadDialogComponent;
    }());
    UploadDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-upload-dialog',
                    template: "<input type=\"file\" #file style=\"display: none\" (change)=\"onFilesAdded()\" multiple />\n\n<div mat-dialog-title id=\"title\">\n  <div>{{ uploadDialogTitle }}</div>\n  <button [disabled]=\"uploading || uploadSuccessful\" mat-raised-button color=\"primary\" class=\"add-files-btn\" (click)=\"addFiles()\">\n    {{ uploadDialogAddFilesButtonText }}\n  </button>\n</div>\n\n<div id=\"conflict\" *ngIf=\"existingFileConflict\">\n  {{ existingFileConflict }} already exists on the server and cannot be overwritten\n</div>\n\n<mat-dialog-content>\n  <mat-list>\n    <mat-list-item *ngFor=\"let file of files\">\n      <h4 mat-line>{{file.name}}</h4>\n      <mat-progress-bar *ngIf=\"progress\" mode=\"determinate\" [value]=\"progress[file.name].progress | async\"></mat-progress-bar>\n    </mat-list-item>\n  </mat-list>\n</mat-dialog-content>\n\n<mat-dialog-actions id=\"actions\">\n  <button *ngIf=\"showCancelButton\" mat-button mat-dialog-close>{{ uploadDialogCancelButtonText }}</button>\n  <button *ngIf=\"files.size > 0\" mat-raised-button color=\"primary\" [disabled]=\"!canBeClosed\" (click)=\"closeDialog()\">{{ primaryButtonText }}</button>\n</mat-dialog-actions>\n",
                    styles: ["#title{display:flex;justify-content:space-between}#actions{display:flex;justify-content:flex-end}#conflict{color:red;font-size:.8em;margin-top:.5em}"]
                },] }
    ];
    UploadDialogComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: UploadService }
    ]; };
    UploadDialogComponent.propDecorators = {
        file: [{ type: core.ViewChild, args: ['file', { static: true },] }]
    };

    var UploadComponent = /** @class */ (function () {
        function UploadComponent(dialog, uploadService) {
            this.dialog = dialog;
            this.uploadService = uploadService;
            this.dialogClosed = new core.EventEmitter();
        }
        UploadComponent.prototype.ngOnInit = function () {
            this.uploadButtonText = this.uploadService.uploadButtonText ?
                this.uploadService.uploadButtonText :
                'Upload';
        };
        UploadComponent.prototype.openUploadDialog = function () {
            var _this = this;
            this.dialog.open(UploadDialogComponent, { width: '50%' })
                .afterClosed().subscribe(function () { return _this.dialogClosed.emit(); });
        };
        return UploadComponent;
    }());
    UploadComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'cp-upload',
                    template: '<button mat-raised-button (click)="openUploadDialog()">{{ uploadButtonText }}</button>'
                },] }
    ];
    UploadComponent.ctorParameters = function () { return [
        { type: dialog.MatDialog },
        { type: UploadService }
    ]; };
    UploadComponent.propDecorators = {
        dialogClosed: [{ type: core.Output }]
    };

    //#region Imports
    //#endregion
    var UploadModule = /** @class */ (function () {
        function UploadModule(parentModule) {
            if (parentModule) {
                throw new Error('UploadModule is already loaded. Import it in the AppModule only');
            }
        }
        UploadModule.forRoot = function (uploadConfig) {
            return {
                ngModule: UploadModule,
                providers: [
                    UploadService,
                    { provide: UploadServiceConfig, useValue: uploadConfig }
                ]
            };
        };
        return UploadModule;
    }());
    UploadModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        animations.BrowserAnimationsModule,
                        http.HttpClientModule,
                        button.MatButtonModule,
                        dialog.MatDialogModule,
                        list.MatListModule,
                        progressBar.MatProgressBarModule
                    ],
                    declarations: [
                        UploadComponent,
                        UploadDialogComponent
                    ],
                    exports: [
                        UploadComponent,
                        UploadDialogComponent
                    ],
                    entryComponents: [
                        UploadDialogComponent
                    ]
                },] }
    ];
    UploadModule.ctorParameters = function () { return [
        { type: UploadModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    // This pipe whitelists URLs so that they aren't prefixed with 'unsafe:' when they render in the DOM
    var SafeUrlPipe = /** @class */ (function () {
        function SafeUrlPipe(domSanitizer) {
            this.domSanitizer = domSanitizer;
        }
        SafeUrlPipe.prototype.transform = function (value) {
            return this.domSanitizer.bypassSecurityTrustUrl(value);
        };
        return SafeUrlPipe;
    }());
    SafeUrlPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'safeUrl'
                },] }
    ];
    SafeUrlPipe.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer }
    ]; };

    var UriSchemePipe = /** @class */ (function () {
        function UriSchemePipe() {
        }
        // https://docs.microsoft.com/en-us/office/client-developer/office-uri-schemes
        UriSchemePipe.prototype.transform = function (value) {
            if (!localStorage.getItem('useUriScheme')) {
                return value;
            }
            var urlSplit = value.split('.');
            var extension = urlSplit[urlSplit.length - 1];
            if (!extension) {
                return value;
            }
            var command = this.command(extension);
            var app = this.app(extension);
            return "ms-" + app + ":" + command + "|u|" + value;
        };
        UriSchemePipe.prototype.app = function (extension) {
            switch (extension.toLowerCase()) {
                // documents
                case 'doc':
                case 'docx':
                case 'docm':
                case 'docb':
                case 'dot':
                case 'dotx':
                case 'dotm': // templates
                    return 'word';
                case 'xls':
                case 'xlsx':
                case 'xlm':
                case 'xlsm':
                case 'xlsb':
                case 'xlw':
                case 'xlt':
                case 'xltx':
                case 'xltm': // templates
                    return 'excel';
                case 'ppt':
                case 'pptx':
                case 'pps':
                case 'ppsx':
                case 'pptm':
                case 'ppsm':
                case 'sldx':
                case 'sldm':
                case 'pot':
                case 'potx':
                case 'potm': // templates
                    return 'powerpoint';
                case 'vsd':
                case 'vsdx':
                case 'vst':
                case 'vstx': // templates
                    return 'visio';
                case 'mdb':
                case 'accdb':
                case 'accde':
                case 'accdr':
                case 'accdt': // templates
                    return 'access';
                case 'mpp':
                case 'mppx':
                case 'mpt': // templates
                    return 'project';
                case 'pub':
                    return 'publisher';
                case 'xsn':
                    return 'infopath';
            }
        };
        UriSchemePipe.prototype.command = function (extension) {
            switch (extension.toLowerCase()) {
                case 'dot':
                case 'dotx':
                case 'dotm':
                case 'xlt':
                case 'xltx':
                case 'xltm':
                case 'pot':
                case 'potx':
                case 'potm':
                case 'vst':
                case 'vstx':
                case 'accdt':
                case 'mpt':
                    return 'nft'; // new from template
                default:
                    var openMode = 'v'; // for view, or 'e' or edit
                    return "of" + openMode; // default: open file as view/edit
            }
        };
        return UriSchemePipe;
    }());
    UriSchemePipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'uriScheme',
                    pure: false
                },] }
    ];

    //#region Imports
    //#endregion
    var UrlModule = /** @class */ (function () {
        function UrlModule() {
        }
        return UrlModule;
    }());
    UrlModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: [
                        SafeUrlPipe,
                        UriSchemePipe
                    ],
                    exports: [
                        SafeUrlPipe,
                        UriSchemePipe
                    ],
                    entryComponents: []
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AuthenticationModule = AuthenticationModule;
    exports.AuthenticationService = AuthenticationService;
    exports.AuthenticationServiceConfig = AuthenticationServiceConfig;
    exports.ConfirmationDialogComponent = ConfirmationDialogComponent;
    exports.DepartmentsPipe = DepartmentsPipe;
    exports.DialogModule = DialogModule;
    exports.EmailModule = EmailModule;
    exports.EmailService = EmailService;
    exports.EmailServiceConfig = EmailServiceConfig;
    exports.EmployeeByDnPipe = EmployeeByDnPipe;
    exports.EmployeeModule = EmployeeModule;
    exports.EmployeePhotoUrlPipe = EmployeePhotoUrlPipe;
    exports.EmployeeService = EmployeeService;
    exports.EmployeeServiceConfig = EmployeeServiceConfig;
    exports.EmployeesWithPropertyValuePipe = EmployeesWithPropertyValuePipe;
    exports.FilterEmployeesPipe = FilterEmployeesPipe;
    exports.InputDialogComponent = InputDialogComponent;
    exports.IsMemberOfPipe = IsMemberOfPipe;
    exports.LoginComponent = LoginComponent;
    exports.LoginFormComponent = LoginFormComponent;
    exports.MessageDialogComponent = MessageDialogComponent;
    exports.SafeUrlPipe = SafeUrlPipe;
    exports.SharePointModule = SharePointModule;
    exports.SharePointPhotoUrlPipe = SharePointPhotoUrlPipe;
    exports.SharePointService = SharePointService;
    exports.SharePointServiceConfig = SharePointServiceConfig;
    exports.SharePointUrlPipe = SharePointUrlPipe;
    exports.SortEmployeesPipe = SortEmployeesPipe;
    exports.UploadComponent = UploadComponent;
    exports.UploadDialogComponent = UploadDialogComponent;
    exports.UploadModule = UploadModule;
    exports.UploadService = UploadService;
    exports.UploadServiceConfig = UploadServiceConfig;
    exports.UriSchemePipe = UriSchemePipe;
    exports.UrlModule = UrlModule;
    exports.ɵa = DialogComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=cleavelandprice-ngx-lib.umd.js.map
