import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { SharePointServiceConfig } from './../model/sharepoint.service.config';
import { SharePointListItemsRequest } from './../model/sharepoint-list-items-request';
import { SharePointUserRequest } from './../model/sharepoint-user-request';
import { SharePointListItem } from './../model/sharepoint-list-item';
import { SharePointEmployeePicture } from './../model/sharepoint-employee-picture';
import { SharePointUser } from '../model/sharepoint-user';
export declare class SharePointService {
    private config;
    private http;
    users: SharePointUser[];
    photos: SharePointEmployeePicture[];
    constructor(config: SharePointServiceConfig, http: HttpClient);
    getListItems(request: SharePointListItemsRequest): Observable<SharePointListItem[]>;
    getPeople(request: SharePointUserRequest, storePeople?: boolean): Observable<SharePointUser[]>;
    getPhotos(storePhotos?: boolean): Observable<SharePointEmployeePicture[]>;
}
